Program mravenci;
uses crt,graph;

type
  tmravenec=object
              barva :byte;
              dx,dy,x,y :integer;
              delka,citac :byte;
              naklad :boolean;
              constructor init(ix,iy:integer;ibarva:byte);
              procedure kresli; virtual;
              destructor done; virtual;
            end;
  pmravenec=^tmravenec;

var
  maxx,maxy,minx,miny :integer;

constructor tmravenec.init(ix,iy:integer;ibarva:byte);
begin
  x:=ix;
  y:=iy;
  dx:=1;
  dy:=1;
  barva:=ibarva;
  putpixel(x,y,barva);
  naklad:=false;
  citac:=0;
  delka:=5;
end;

procedure tmravenec.kresli;
var
  nx,ny :integer;
begin
  inc(citac);
  if citac>=delka then
  begin
    repeat
      dx:=random(3)-1;
      dy:=random(3)-1;
    until not((dx=0) and (dy=0));
    delka:=random(100);
    citac:=0;
  end;
  nx:=x+dx;
  if (nx<minx) or (nx>maxx) then
  begin
    dx:=-1*dx;
    nx:=x+dx;
  end;
  ny:=y+dy;
  if (ny<miny) or (ny>maxy) then
  begin
    dy:=-1*dy;
    ny:=y+dy;
  end;
  if getpixel(nx,ny)=1 then
  begin
    if naklad=false then
    begin
      naklad:=true;
      barva:=3;
    end
  else
    begin
      naklad:=false;
      barva:=2;
      putpixel(x,y,1);
      dx:=-1*dx;
      dy:=-1*dy;
      x:=x+dx;
      y:=y+dy;
      nx:=x+dx;
      ny:=y+dy;
      delka:=5;
      citac:=0;
    end;
  end;
  putpixel(x,y,black);
  putpixel(nx,ny,barva);
  x:=nx;
  y:=ny;
end;

destructor tmravenec.done;
begin
end;

var
  pocet:word;


procedure main;
var
  ch :char;
  n,m :word;
  mrv1 :pmravenec;
  mrv2 :pmravenec;
  mrv3 :pmravenec;
  mrv4 :pmravenec;
  mrv5 :pmravenec;
  mrv6 :pmravenec;
  mrv7 :pmravenec;
  mrv8 :pmravenec;
  mrv9 :pmravenec;
  mrv10 :pmravenec;
begin
  minx:=10;
  miny:=10;
  maxx:=getmaxx-10;
  maxy:=getmaxy-10;
  pocet:=300;
  randomize;
  for n:=0 to pocet do putpixel(random(maxx-minx)+minx,random(maxy-miny)+miny,1);
  mrv1:=new(pmravenec,init(100,100,2));
  mrv2:=new(pmravenec,init(100,100,2));
  mrv3:=new(pmravenec,init(100,100,2));
  mrv4:=new(pmravenec,init(100,100,2));
  mrv5:=new(pmravenec,init(100,100,2));
  mrv6:=new(pmravenec,init(100,100,2));
  mrv7:=new(pmravenec,init(100,100,2));
  mrv8:=new(pmravenec,init(100,100,2));
  mrv9:=new(pmravenec,init(100,100,2));
  mrv10:=new(pmravenec,init(100,100,2));
  repeat
    mrv1^.kresli;
    mrv2^.kresli;
    mrv3^.kresli;
    mrv4^.kresli;
    mrv5^.kresli;
    mrv6^.kresli;
    mrv7^.kresli;
    mrv8^.kresli;
    mrv9^.kresli;
    mrv10^.kresli;
    delay(30);
  until keypressed;
  ch:=readkey;
  dispose(mrv1,done);
  dispose(mrv2,done);
  dispose(mrv3,done);
  dispose(mrv4,done);
  dispose(mrv5,done);
  dispose(mrv6,done);
  dispose(mrv7,done);
  dispose(mrv8,done);
  dispose(mrv9,done);
  dispose(mrv10,done);
  pocet:=0;
  for n:=0 to getmaxx do
  begin
    for m:=0 to getmaxy do
    begin
      if getpixel(n,m)=1 then inc(pocet);
      if getpixel(n,m)=3 then inc(pocet);
    end;
  end;
end;

var
 grDriver: Integer;
 grMode: Integer;
begin
 grDriver := 1;
 grMode:=1;
 InitGraph(grDriver,grMode,'');
 main;
 CloseGraph;
 writeln('pocet nakladu: ',pocet,'<');
end.